(function () {
  "use strict";

  var Error = {};

  Error.SERVER_ERROR = {
    app_status_code: 1000001,
    message: {
      dev: "try catch err: {message}",
      user: "something went wrong. please try again later",
      log: "try catch err: {message}"
    }
  };

  Error.DB_ERROR = {
    app_status_code: 1000002,
    message: {
      dev: "DB Error occurred: {err}",
      user: "internal system error occurred. Please try again",
      log: "db error occurred: {err} for {endpoint}"
    }
  };

  Error.MISSING_FRAME_ID = {
    app_status_code: 1000003,
    message: {
      dev: "Frame id should be present",
      user: "Frame id should be present to access this resource",
      log: "Frame id should be present for {endpoint}"
    }
  };

  Error.MISSING_VIDEO_ID = {
    app_status_code: 1000004,
    message: {
      dev: "Video id should be present",
      user: "Video id should be present to access this resource",
      log: "Video id should be present for {endpoint}"
    }
  };

  Error.MISSING_LABEL_ID = {
    app_status_code: 1000005,
    message: {
      dev: "Label id should be present",
      user: "Label id should be present to access this resource",
      log: "Label id should be present for {endpoint}"
    }
  };

  Error.MISSING_RESOURCE_ID = {
    app_status_code: 1000006,
    message: {
      dev: "Resource id should be present",
      user: "Resource id should be present to access this resource",
      log: "Resource id should be present for {endpoint}"
    }
  };

  Error.MISSING_RESOURCE_NAME = {
    app_status_code: 1000007,
    message: {
      dev: "Resource name should be present",
      user: "Resource name should be present to access this resource",
      log: "Resource name should be present for {endpoint}"
    }
  };

  Error.MISSING_PERMISSION_ID = {
    app_status_code: 1000008,
    message: {
      dev: "Permission id should be present",
      user: "Permission id should be present to access this resource",
      log: "Permission id should be present for {endpoint}"
    }
  };

  Error.MISSING_PERMISSION_RESOURCE_ID = {
    app_status_code: 1000009,
    message: {
      dev: "Permission resource id should be present",
      user: "Permission resource id should be present to access this resource",
      log: "Permission resource id should be present for {endpoint}"
    }
  };

  Error.MISSING_PERMISSION_RESOURCE_NAME = {
    app_status_code: 1000010,
    message: {
      dev: "Permission resource name should be present",
      user: "Permission resource name should be present to access this resource",
      log: "Permission resource name should be present for {endpoint}"
    }
  };


  Error.MISSING_PERMISSION_RESOURCE_ACTION = {
    app_status_code: 1000011,
    message: {
      dev: "Permission resource action should be present",
      user: "Permission resource action should be present to access this resource",
      log: "Permission resource action should be present for {endpoint}"
    }
  };

  Error.MISSING_USER_ID = {
    app_status_code: 1000012,
    message: {
      dev: "userId is missing",
      user: "userId is missing",
      log: "userId is missing for {endpoint}"
    }
  };

  Error.MISSING_USER_EMAIL = {
    app_status_code: 1000013,
    message: {
      dev: "userEmail is missing",
      user: "userEmail is missing",
      log: "userEmail is missing for {endpoint}"
    }
  };

  Error.MISSING_USER_PASSWORD = {
    app_status_code: 1000014,
    message: {
      dev: "userPassword is missing",
      user: "userPassword is missing",
      log: "userPassword is missing for {endpoint}"
    }
  };

  Error.MISSING_USER_NEW_PASSWORD = {
    app_status_code: 1000015,
    message: {
      dev: "usernewPassword is missing",
      user: "usernewPassword is missing",
      log: "usernewPassword is missing for {endpoint}"
    }
  };

  Error.MISSING_RSK = {
    app_status_code: 1000016,
    message: {
      dev: "rsk is missing",
      user: "You are not authorized to access this resource",
      log: "rsk is missing for {endpoint}"
    }
  };

  Error.MISSING_TOKEN_ID = {
    app_status_code: 1000017,
    message: {
      dev: "tokenId is missing",
      user: "tokenId is missing",
      log: "tokenId is missing for {endpoint}"
    }
  };

  Error.MISSING_ORGANIZATION_ID = {
    app_status_code: 1000018,
    message: {
      dev: "organizationId is missing",
      user: "organizationId is missing",
      log: "organizationId is missing for {endpoint}"
    }
  };

  Error.MISSING_RESOURCE_ACTION = {
    app_status_code: 1000019,
    message: {
      dev: "Resource Action should be present",
      user: "You are not authorized to access this resource",
      log: "Resource action missing for {endpoint}"
    }
  };

  Error.MISSING_TOKEN = {
    app_status_code: 1000020,
    message: {
      dev: "Token should be present",
      user: "Token should be present",
      log: "Token missing for {endpoint}"
    }
  };

  Error.MISSING_USER_PERMISSIONS = {
    app_status_code: 1000021,
    message: {
      dev: "Permissions should be present",
      user: "Permissions should be present",
      log: "Permissions missing for {endpoint}"
    }
  };

  Error.MISSING_USER_TOKENS = {
    app_status_code: 1000022,
    message: {
      dev: "Token should be present",
      user: "Token should be present",
      log: "Token missing for {endpoint}"
    }
  };

  Error.INVALID_VIDEO_ID = {
    app_status_code: 1000023,
    message: {
      dev: "videoId is invalid",
      user: "videoId is invalid",
      log: "invalid videoId for {endpoint}"
    }
  };

  Error.INVALID_USER_ID = {
    app_status_code: 1000024,
    message: {
      dev: "userId is invalid",
      user: "userId is invalid",
      log: "userId is invalid for {endpoint}"
    }
  };

  Error.INVALID_TOKEN_ID = {
    app_status_code: 1000025,
    message: {
      dev: "tokenId is invalid",
      user: "tokenId is invalid",
      log: "tokenId is invalid for {endpoint}"
    }
  };

  Error.INVALID_PERMISSION_ID = {
    app_status_code: 1000026,
    message: {
      dev: "permissionId is invalid",
      user: "permissionId is invalid",
      log: "permissionId is invalid for {endpoint}"
    }
  };

  Error.INVALID_PERMISSION = {
    app_status_code: 1000027,
    message: {
      dev: "permission is invalid",
      user: "permission is invalid",
      log: "permission is invalid for {endpoint}"
    }
  };

  Error.INVALID_TOKEN_EXPIRY = {
    app_status_code: 1000028,
    message: {
      dev: "token expiry is invalid",
      user: "token expiry is invalid",
      log: "token expiry is invalid for {endpoint}"
    }
  };

  Error.INVALID_TOKEN = {
    app_status_code: 1000029,
    message: {
      dev: "token is invalid",
      user: "token is invalid",
      log: "token is invalid for {endpoint}"
    }
  };

  Error.INVALID_ORGANIZATION_ID = {
    app_status_code: 1000030,
    message: {
      dev: "organization id is invalid",
      user: "organization id is invalid",
      log: "organization id is invalid for {endpoint}"
    }
  };

  Error.INVALID_USER_EMAIL = {
    app_status_code: 1000031,
    message: {
      dev: "email is invalid",
      user: "email is invalid",
      log: "email is invalid for {endpoint}"
    }
  };

  Error.INVALID_USER_PASSWORD = {
    app_status_code: 1000032,
    message: {
      dev: "password is invalid",
      user: "password is invalid",
      log: "password is invalid for {endpoint}"
    }
  };

  Error.INVALID_USER_RSK = {
    app_status_code: 1000033,
    message: {
      dev: "user rsk is invalid",
      user: "You are not authorized to access this resource",
      log: "user rsk is invalid for {endpoint}"
    }
  };

  Error.INVALID_LABELLING_STATUS = {
    app_status_code: 1000034,
    message: {
      dev: "labelling status is invalid",
      user: "labelling status is invalid",
      log: "labelling status is invalid for {endpoint}"
    }
  };

  Error.INVALID_RSK = {
    app_status_code: 1000035,
    message: {
      dev: "rsk is invalid",
      user: "You are not authorized to access this resource",
      log: "rsk is invalid for {endpoint}"
    }
  };

  Error.ENDPOINT_NOT_EXIST = {
    app_status_code: 100000,
    message: {
      dev: "This endpoint {endpoint} does not exist",
      user: "Oops! You have reached a dead-end",
      log: "{endpoint} does not exist"
    }
  };

  Error.INVALID_AUTH_TOKEN = {
    app_status_code: 100001,
    message: {
      dev: "Token `{authToken}` is invalid",
      user: "You are not authorized to access this resource",
      log: "Token `{authToken}` is invalid for {endpoint}"
    }
  };

  Error.MISSING_AUTH_TOKEN = {
    app_status_code: 100002,
    message: {
      dev: "Token should be present",
      user: "You are not authorized to access this resource",
      log: "Token is missing for {endpoint}"
    }
  };

  Error.INVALID_RESOURCE_ACTION = {
    app_status_code: 100006,
    message: {
      dev: "Resource Action is invalid",
      user: "You are not authorized to access this resource",
      log: "Resource action invalid for {endpoint}"
    }
  };

  Error.INVALID_CLIENT = {
    app_status_code: 100007,
    message: {
      dev: "Client object is invalid",
      user: "You are not authorized to access this resource",
      log: "Client object invalid for {endpoint}"
    }
  };

  Error.MISSING_TICKET = {
    app_status_code: 100009,
    message: {
      dev: "ticket should be present",
      user: "You are not authorized to access this resource",
      log: "ticket is missing for {endpoint}"
    }
  };

  Error.INVALID_TICKET = {
    app_status_code: 100010,
    message: {
      dev: "ticket is invalid",
      user: "You are not authorized to access this resource",
      log: "ticket is invalid for {endpoint}"
    }
  };

  Error.MISSING_METHOD = {
    app_status_code: 100012,
    message: {
      dev: "method param is missing",
      user: "unable to process your request",
      log: "method param missing for {endpoint}"
    }
  };

  Error.INVALID_METHOD = {
    app_status_code: 100013,
    message: {
      dev: "method param is invalid",
      user: "unable to process your request",
      log: "method param invalid for {endpoint}"
    }
  };

  Error.MISSING_ENDPOINT = {
    app_status_code: 100014,
    message: {
      dev: "endpoint param is missing",
      user: "unable to process your request",
      log: "endpoint param invalid for {endpoint}"
    }
  };

  Error.INVALID_ENDPOINT = {
    app_status_code: 100015,
    message: {
      dev: "endpoint param is invalid",
      user: "unable to process your request",
      log: "endpoint param invalid for {endpoint}"
    }
  };

  Error.DUPLICATE_ACL = {
    app_status_code: 100018,
    message: {
      dev: "duplicate entry attempted for acl",
      user: "Provided ACL already exists for this token",
      log: "duplicate entry attempted for {endpoint}"
    }
  };

  Error.INVALID_ACL = {
    app_status_code: 100019,
    message: {
      dev: "acl param is invalid or malformed",
      user: "ACL param is invalid or malformed",
      log: "invalid ACL param for {endpoint}"
    }
  };

  Error.MISSING_ACL = {
    app_status_code: 100022,
    message: {
      dev: "ACL param is missing",
      user: "ACL should be present",
      log: "ACL param missing for {endpoint}"
    }
  };

  Error.NO_DATA = {
    app_status_code: 100023,
    message: {
      dev: "No data present for the query params",
      user: "There is no data for the query",
      log: "No data to be returned for {endpoint}"
    }
  };

  Error.DUPLICATE_EMAIL = {
    app_status_code: 100033,
    message: {
      dev: "email already exists",
      user: "email already exists",
      log: "duplicate email param provided for {endpoint}"
    }
  };

  Error.CLIENT_ID_NOT_EXIST = {
    app_status_code: 100034,
    message: {
      dev: "client id does not exist",
      user: "client id does not exist",
      log: "non existing client id provided for {endpoint}"
    }
  };

  Error.INVALID_ROLE = {
    app_status_code: 100039,
    message: {
      dev: "role cannot be {role}",
      user: "role cannot be {role}",
      log: "invalid role param for {endpoint}"
    }
  };

  Error.INVALID_RESOURCE_ID = {
    app_status_code: 100042,
    message: {
      dev: "resource id is invalid",
      user: "resource id is invalid",
      log: "invalid resource id param for {endpoint}"
    }
  };

  Error.MISSING_START_TIME = {
    app_status_code: 1000140,
    message: {
      dev: "missing start time",
      user: "missing start time",
      log: "missing start time for {endpoint}"
    }
  };

  Error.INVALID_START_TIME = {
    app_status_code: 1000141,
    message: {
      dev: "invalid start time",
      user: "invalid start time",
      log: "invalid start time for {endpoint}"
    }
  };

  Error.MISSING_END_TIME = {
    app_status_code: 1000142,
    message: {
      dev: "missing end time",
      user: "missing end time",
      log: "missing end time for {endpoint}"
    }
  };

  Error.INVALID_END_TIME = {
    app_status_code: 1000143,
    message: {
      dev: "invalid end time",
      user: "invalid end time",
      log: "invalid end time for {endpoint}"
    }
  };

  Error.MISSING_DURATION = {
    app_status_code: 1000144,
    message: {
      dev: "duration is missing",
      user: "duration is missing",
      log: "duration is missing for {endpoint}"
    }
  };

  Error.INVALID_DURATION = {
    app_status_code: 1000145,
    message: {
      dev: "duration is invalid",
      user: "duration is invalid",
      log: "duration is invalid for {endpoint}"
    }
  };

  Error.MISSING_TOKEN_NAME = {
    app_status_code: 1000250,
    message: {
      dev: "token name is mandatory",
      user: "token name needs to be present",
      log: "token name is mandatory"
    }
  };

  Error.NOT_UPDATABLE_TOKEN = {
    app_status_code: 1000251,
    message: {
      dev: "token cannot be updated",
      user: "token cannot be updated",
      log: "token cannot be updated"
    }
  };

  Error.NOT_DELETABLE_TOKEN = {
    app_status_code: 1000252,
    message: {
      dev: "token cannot be deleted",
      user: "token cannot be deleted",
      log: "token cannot be deleted"
    }
  };

  Error.MISSING_FOLDER_ID = {
    app_status_code: 1000253,
    message: {
      dev: "missing folder id",
      user: "missing folder id",
      log: "missing folder id"
    }
  };

  Error.MISSING_FOLDER_VIDEO_ID = {
    app_status_code: 1000253,
    message: {
      dev: "missing folder video id",
      user: "missing folder video id",
      log: "missing folder video id"
    }
  };

  module.exports = Error;
  
})();
