(function () {
  "use strict";
  var Helpers = function () {},
  ErrorConstants = require("/etc/label-config/constants/errors");

  /**
   * takes in a JSON object and converts it into a request query param string
   * @param object
   * @return {string} queryParams
   */
  Helpers.objectToQueryParams = function (object) {

    if (typeof object !== "object" || Array.isArray(object) || !Object.keys(object).length) {
      console.log("nothing to convert to param.. returning");
      return "";
    }

    return Object.keys(object).map(function (key) {
      return encodeURIComponent(key) + "=" + encodeURIComponent(object[key])
    }).join("&");
  };

  Helpers.getErrorConstant = function (errorCode) {
    var key,
      errorConstant;

    for (key in ErrorConstants) {

      if (!ErrorConstants.hasOwnProperty(key)) {
        continue;
      }

      errorConstant = ErrorConstants[key];

      if (errorConstant.app_status_code === errorCode) {
        return errorConstant;
      }
    }

    return {};
  };

  module.exports = Helpers;
})();
